package ffilechooser;

import java.awt.AWTEvent;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.event.AWTEventListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Vector;

import javax.swing.JFrame;

import ffilechooser.FMonitor.MonitorListener;


public class FFrame extends JFrame {

	FFrameListener frameListener;


	public float x;
	public float y;	
	public float width;
	public float height;

	public int frameWidthAvailable = 0;
	public int frameHeightAvailable = 0;



	public FMonitor monitor;	
	MonitorListener monitorListener;


	public FFrame(final FFrameListener frameListener) {

		this.frameListener	= frameListener;

		x 					= 0.0f;
		y 					= 0.0f;
		width 				= 0.1f;
		height 				= 0.1f;


		monitorListener = new MonitorListener() {

			@Override
			public void monitorResolutionChanged() {				

				repaint();

				frameWidthAvailable  = monitor.convertFloatToRealWidth(width);
				frameHeightAvailable = monitor.convertFloatToRealHeight(height);
				
				frameListener.monitorResolutionChanged();
			}

			@Override
			public void frameResized() {

				
				width 	= monitor.convertRealToFloatWidth(getWidth()); 
				height 	= monitor.convertRealToFloatHeight(getHeight());

				frameWidthAvailable  =  monitor.convertFloatToRealWidth(width);
				frameHeightAvailable =  monitor.convertFloatToRealHeight(height)-monitor.toolBarHeight;		
				
				frameListener.frameResized();
			}
			@Override
			public void frameMoved() {

				x = monitor.convertRealToFloatWidth(getX()); 
				y = monitor.convertRealToFloatHeight(getY()); 
				
				frameListener.frameMoved();
			}
		};

		monitor = new FMonitor(this, monitorListener);

	}


	public void repaint() {		
		
		setBounds(monitor.convertFloatToRealWidth(x), monitor.convertFloatToRealHeight(y), monitor.convertFloatToRealWidth(width), monitor.convertFloatToRealHeight(height));	
	}


	public void setSize(float width, float height) {
		//System.out.println("setSize");

		this.width 	= width;
		this.height 	= height;	
		repaint();
	}

	public void setBounds(float x, float y, float width, float height) {
		//System.out.println("setBounds");

		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;	
		repaint();
	}

	public void setLocation(float x, float y) {

		this.x = x;
		this.y = y;
		repaint();
	}

	public void setMinimumSize(float width, float height) {

		setMinimumSize(new Dimension(monitor.convertFloatToRealWidth(width), monitor.convertFloatToRealHeight(height)));
	}

}
