package ffilechooser;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;

import javax.swing.ImageIcon;
import javax.swing.JLabel;



public class JImage extends JLabel {

	Image image;	
	ImageObserver imageObserver;

	BufferedImage imageLinked;
	
	
	float alpha = 1.0f;
	
	int iWidth = 1;
	int iHeight = 1;

	public JImage() {}

	
	JImage(ImageIcon icon) {
		setImageIcon((ImageIcon)icon);
	}
	
	public void setIcon(ImageIcon icon) {		
		setImageIcon((ImageIcon)icon);
	}

	public void setImageIcon(ImageIcon icon) {

		image = icon.getImage();		
		imageObserver = icon.getImageObserver();	

		
		int w = image.getWidth(imageObserver);
		int h = image.getHeight(imageObserver);

		imageLinked = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
		Graphics2D g2 = imageLinked.createGraphics();
		g2.drawImage(image, 0, 0, imageObserver);
		g2.dispose();
					
	
				
		int x = 0;
		int y = h - 4;
		
		for(int iy=0;iy<4;iy++) {
			for(int ix=0;ix<4;ix++) {				
				imageLinked.setRGB(x+ix, y+iy, new Color(linkArrowPixelMatrixColors4x5[iy][ix]).getRGB());
			}
		}
		
		repaint();
	}

	public void setAlpha(float alpha) {
		this.alpha = alpha;
		repaint();
	}

	boolean drawLink = false;

	public void drawLink(boolean state) {

		drawLink = state;	
		
	}
	
	public void setImageWidth(int width) {		
		this.iWidth = width;
	}
	
	public void setImageHeight(int height) {		
		this.iHeight = height;
		
		
	
		
	}
	
	public int getImageWidth() {		
		return iWidth;
	}
	
	public int getImageHeight() {		
		return iHeight;
	}
	
	

	int[][] linkArrowPixelMatrixColors4x5 = new int[][] {  { 0xe3e3e3,0x666769,0x212224,0x212224},{ 0xafb0b0,0x666769,0x3d3d41,0x212224},{ 0xffffff,0x545456,0xabacac,0x666769},{ 0xe3e3e3,0x212224,0xffffff,0xdcdcdc},{ 0xcecece,0xffffff,0xadadad,0xa6a6a6}};

	public void paint( Graphics g ) {
		
		
		super.paint(g); // * Das muss hier stehen, damit in der Tabelle hinter dem Icon die Hintergrundfarben angezeigt werden! *
		
		Graphics2D g2 = (Graphics2D) g;
		AlphaComposite newComposite =  AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha);
		g2.setRenderingHint(RenderingHints.KEY_RENDERING,  RenderingHints.VALUE_RENDER_QUALITY);
		g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
		g2.setComposite(newComposite);

		
		int x 		= 0;
		int y 		= 0;
		int width 	= iWidth;
		int height 	= iHeight;
		
		if(image != null) {

			x = (getWidth()-width)/2;
			y = (getHeight()-height)/2;

			if(!drawLink) g2.drawImage(image,  x , y, width , height , imageObserver);		
		}
		
		g2.setColor(Color.RED);
		if(drawLink) {

			g2.drawImage(imageLinked,  x , y, width , height , null);	
		}
		
		g2.dispose();	
	}		
}