package main;
import java.awt.AWTEvent;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.event.AWTEventListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.FileStore;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.attribute.PosixFilePermissions;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.prefs.Preferences;

import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLayeredPane;
import javax.swing.SortOrder;
import javax.swing.SwingUtilities;

import ffilechooser.Directory;
import ffilechooser.DirectoryTable;
import ffilechooser.FFileChooser;
import ffilechooser.FFrame;
import ffilechooser.FPanel;
import ffilechooser.Functions;

public class FileDir extends FPanel {


	public boolean activeDirectory 		= false;

	String volumeName = "-1";
	String oldVolumeName = "";


	public FileDirectoryTable directoryTable;

	public String[] columnNames = {""," Name", " Size"};

	public String directoryPath = "/Volumes";
	public String directoryPathOld = "/Volumes";




	Preferences prefs = Preferences.userNodeForPackage(FileDir.class);
	String PREF_NAME_directory_path 			= "directory_path";


	String mouseClickCheckLastClickedCellName = "";


	BufferedImage appIconImage 					= null;
	BufferedImage dirImage 						= null;
	BufferedImage fileImage 						= null;
	BufferedImage appImage 						= null;

	public BufferedImage backImage 				= null;
	BufferedImage backOffImage 					= null;	
	public BufferedImage forwardImage 			= null;
	public BufferedImage forwardOffImage 		= null;


	public int width = 1;

	boolean showHiddenFiles 		= false;

	FileDir directory;





	public int directoryIconRowWidth;


	// * Directory *

	public Font directoryTableHeaderFont;
	public int directoryTableHeaderRowHeight;
	public int directoryTableRowHeight;

	public int directoryNameRowMinWidth;
	public int directoryModifiedRowWidth;
	public int directorySizeRowWidth;
	public int directoryLastRowWidth;

	public Font directoryTableFont;
	public int directoryIconWidth;


	// * Drives *
	public float drivesPanelImageMultip  = 0.65f;

	public int drivesPanelCellWidth;
	public int drivesPanelCellHeight;


	float monitorOldWidth = 0;
	float monitorOldHeight = 0;


	MacC64FileOperator macC64FileOperator;
	String[] favorites;	


	public String filePath = "";

	int side = 0;

	public FileDir(MacC64FileOperator macC64FileOperator, int side, String[] favorites, String fontName, String prefsString) {
		super(macC64FileOperator.fframe);

		this.side = side;

		PREF_NAME_directory_path += "_" + prefsString;

		this.directory 		= this;
		this.macC64FileOperator 	= macC64FileOperator;
		this.favorites 		= favorites;

		this.directoryTableHeaderFontName 		= fontName;
		this.directoryTableFontName 				= fontName;


		directoryPath = prefs.get(PREF_NAME_directory_path, directoryPath);		
		if(directoryPath == null || new File(directoryPath).exists() == false) directoryPath = "/Volumes";

		Toolkit.getDefaultToolkit().addAWTEventListener(new AWTEventListener() {

			@Override
			public void eventDispatched(AWTEvent event) {

				if(macC64FileOperator.fframe.monitor.width != monitorOldWidth || macC64FileOperator.fframe.monitor.height != monitorOldHeight) {

					monitorOldWidth = macC64FileOperator.fframe.monitor.width;
					monitorOldHeight = macC64FileOperator.fframe.monitor.height;

					updateUI();		

					directoryTable.getTableHeader().setPreferredSize(new Dimension(getWidth(), directory.directoryTableHeaderRowHeight));
					directoryTable.setRowHeight( directory.directoryTableRowHeight );			
					directoryTable.getTableHeader().setFont(directory.directoryTableHeaderFont);					
					directoryTable.setDirectoryDesign();	
				}
			}
		}, AWTEvent.PAINT_EVENT_MASK);


		updateUI();		


		// * Abfrage ob Verzeichnis beim Start existiert *
		// * Wenn ein Laufwerk entfernt wurde, und dann das Verzeichnis nicht mehr existiert, auf das /Volumes Verzeichnis wechseln *
		if(new File(directoryPath).exists() == false) directoryPath = "/Volumes";



		try	{ InputStream in = getClass().getResourceAsStream("/ffileshooser_pack/dir.png"); dirImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = getClass().getResourceAsStream("/ffileshooser_pack/file.png"); fileImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = getClass().getResourceAsStream("/ffileshooser_pack/back.png"); backImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = getClass().getResourceAsStream("/ffileshooser_pack/back_off.png"); backOffImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = getClass().getResourceAsStream("/ffileshooser_pack/forward.png"); forwardImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = getClass().getResourceAsStream("/ffileshooser_pack/forward_off.png"); forwardOffImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = getClass().getResourceAsStream("/ffileshooser_pack/app.png"); appImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}




		directoryTable 	= new FileDirectoryTable(this);	
		updateUI();
		updateViews();

		addComponentListener(new ComponentListener(){

			@Override
			public void componentHidden(ComponentEvent arg0) {}
			@Override
			public void componentMoved(ComponentEvent e) {}
			@Override
			public void componentShown(ComponentEvent arg0) {}
			@Override
			public void componentResized(ComponentEvent e) {


				// * AutoResize *
				updateViews();

				// * Das hier ist sehr wichtig... das korrigiert nicht gut platzierte Layers!!! *
				revalidate();


				// * Nur hier  bei Resize Window die Empty Rows in der Tabelle anpassen... 
				//   ...weil in der UpdateViews() for i Schleife gibts dann massig Fehler!!! *				
				directoryTable.fillTableWithEmptyRows(); // * zuerst Fill... dann Sort, sonst klappt das mit den Leeren Zeilen nicht *

			}
		});



		// * Das muss hier in einem "invokeLater" stehen, damit das JTable auch die leeren Rows anzeigt!  *
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {

				directoryTable.setDirectoryDesign();	
				directoryTable.invalidate();

				showDirectory();
			}
		});
	}



	public String directoryTableHeaderFontName 		= "";
	public int directoryTableHeaderFontType 			= Font.PLAIN;
	public float directoryTableHeaderFontSize 		= 0.01f;

	public String directoryTableFontName 			= "";
	public int directoryTableFontType 				= Font.PLAIN;
	public float directoryTableFontSize 				= 0.01f;


	public void updateUI() {

		directoryIconRowWidth 			= macC64FileOperator.fframe.monitor.convertFloatToRealWidth(0.01171875f);
		directoryTableHeaderFont 		= new Font(directoryTableHeaderFontName, directoryTableHeaderFontType, macC64FileOperator.fframe.monitor.convertFloatToRealHeight(directoryTableHeaderFontSize));
		directoryTableHeaderRowHeight 	= macC64FileOperator.fframe.monitor.convertFloatToRealHeight(0.017361112f);
		directoryTableFont				= new Font(directoryTableFontName, directoryTableFontType, macC64FileOperator.fframe.monitor.convertFloatToRealHeight(directoryTableFontSize));
		directoryTableRowHeight 			= macC64FileOperator.fframe.monitor.convertFloatToRealHeight(0.017361112f);
		directoryNameRowMinWidth 		= macC64FileOperator.fframe.monitor.convertFloatToRealWidth(0.0446875f);
		directoryModifiedRowWidth 		= macC64FileOperator.fframe.monitor.convertFloatToRealWidth(0.05859375f);
		directorySizeRowWidth 			= macC64FileOperator.fframe.monitor.convertFloatToRealWidth(0.05296875);
		directoryLastRowWidth 			= macC64FileOperator.fframe.monitor.convertFloatToRealWidth(0.0078125f);
		directoryIconWidth 				= macC64FileOperator.fframe.monitor.convertFloatToRealWidth(0.00625f);

		drivesPanelCellWidth 			= macC64FileOperator.fframe.monitor.convertFloatToRealWidth(0.046875f);
		drivesPanelCellHeight 			= macC64FileOperator.fframe.monitor.convertFloatToRealHeight(0.018055556f);
	}



	private void updateViews() {

		// * Directory Inhalt updaten *
		directoryTable.setBounds(0, 0, getWidth(), getHeight());
		directoryTable.getScrollPane().setBounds(0, 0, getWidth(), getHeight());		
	}

	public void clearSelection() {

		directoryTable.clearSelection();
	}


	public void switchAllToolsOff() {


		directoryTable.setVisible(false); // * das muss beleiben, weil alle Layer muessen aus! Nur einer darf an sein, sonst gibt es Grafikfehler! *
		directoryTable.getScrollPane().setVisible(false); // * das muss bleiben, weil alle Layer muessen aus! Nur einer darf an sein, sonst gibt es Grafikfehler! *

		remove(directoryTable.getScrollPane());
	}


	public void showDirectory() {

		if(getComponentZOrder(directoryTable.getScrollPane()) == -1) add(directoryTable.getScrollPane());
		directoryTable.setVisible(true);		
		directoryTable.getScrollPane().setVisible(true);		
		reloadDir();
	}


	public void reloadDir() {

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {

				loadDirectory(directoryPath, false);
				directoryTable.invalidate();		
				
			}
		});	
	}


	public void clickedDirectoryEmptyRow() {

		if(macC64FileOperator.gui != null) macC64FileOperator.gui.updateButtons();
	}

	public void clickedDirectoryColumn(String name) {

		setSelectedFile(name);
	}

	public void doubleClickedDirectoryColumn(String name) {

		String newPath = directoryPath + "/" +  name ;
		newPath = newPath.replace("//", "/");

		// * Fix:  "/Volumes/MacOS/Voumes" ... to "/Volumes" *
		if(newPath.indexOf("/Volumes", 2) > 0) newPath = "/Volumes";


		if(new File(newPath).isDirectory() && name.toLowerCase().contains(".app") == false &&  name.toLowerCase().contains(".eyetv") == false) {

			animateWaitCursor();

			loadDirectory(newPath, true);		

			waitMode = false;
			setCursor( Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		}
		else {						

			setSelectedFile(name);

			if(name.toLowerCase().contains(".d64") == true) macC64FileOperator.switchDirMode(side, MacC64FileOperator.MODE_D64_DIR);			
		}

		activateDirectory();
	}

	private void setSelectedFile(String name) {

		String newPath = "";

		if(name != null) {

			File f = new File(name);

			if(f.isDirectory()) newPath = name;
			else {

				newPath = directoryPath + "/" +  name;
				newPath = newPath.replace("//", "/");
			}	

			filePath = newPath;
		}

		if(macC64FileOperator.gui != null) macC64FileOperator.gui.updateButtons();
	}

	public String[] getSelectedFiles() {

		int[] selectedRows 		= directoryTable.getSelectedRows();		
		String[] selectedFiles 	= new String[selectedRows.length];

		try {for(int i=0;i<selectedRows.length;i++) selectedFiles[i] = directoryTable.getValueAt(selectedRows[i], 1).toString();} catch(Exception e) {}

		return selectedFiles;
	}



	public boolean waitMode = false;

	public void animateWaitCursor() {


		Thread T=new Thread(new Runnable() {

			@Override
			public void run() {

				try {

					waitMode = true;

					Thread.sleep(500); // *  erst nach 500ms anzeigen, weil sonst fast immer der Ball angezeigt wird! *

					while(waitMode) {

						for(int i=0;i<32;i++) {

							if(waitMode == false) break;
							setCursor( Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR) );  

							try {Thread.sleep(25);} catch (InterruptedException e) {e.printStackTrace();	}
						}
					}
					setCursor( Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
				}
				catch(Exception e) {e.printStackTrace();}
			}
		} );
		T.start();		

	}


	long availableDiskSpace 	= 0;
	public boolean directoryLoading = false;

	public void loadDirectory(String path, boolean addToMemory) {

		directoryLoading = true;

		try {				

			setSelectedFile(path);				


			directoryTable.tableModel.setDataVector(loadDirectoryFiles(path), columnNames);	
			directoryTable.invalidate();

			directoryPath = path; // * Wenn Directory geoeffnet werden konnte, neuen Pfad uebernehmen * 
			prefs.put(PREF_NAME_directory_path, directoryPath);


			// * Vom Directory Path das Volume ermittlen *

			String volume = "/";
			if(directoryPath.compareTo("/") != 0) {

				File volumesRoot = new File("/Volumes");
				File[] volumes = volumesRoot.listFiles();

				for(int i=0;i<volumes.length;i++) {

					if(directoryPath.startsWith(volumes[i].getAbsolutePath() + "/")) { //  + "/"  ist wichtig! sonst gibt es kein Wechsel bei "Sonstiges" auf "Sonstiges2"

						volume = volumes[i].getAbsolutePath();
						break;
					}
				}
			}


			// * Disk-Daten von dem Volumen aktualisieren, wenn Volume gewechselt wurde! *
			if(volume.compareTo(oldVolumeName) != 0) {
				oldVolumeName = volume;				

				try {

					FileStore store = null;
					store = Files.getFileStore(Paths.get(oldVolumeName));
					availableDiskSpace 	= store.getUsableSpace();					
				}
				catch (Exception e)  {					
					e.printStackTrace();
				}					
			}

			// * Watcher updaten, wenn Verzeichnis gewechselt wurde! *
			if(directoryPathOld.compareTo(directoryPath) != 0) {

				directoryPathOld = directoryPath;
			}			



			String name = new File(directoryPath).getName();
			if(name.compareTo("") == 0) name = "/";

			ImageIcon imageIcon = new ImageIcon();

			try {

				Icon image = fc.getUI().getFileView(fc).getIcon(new File(directoryPath));					
				BufferedImage bi = new BufferedImage(image.getIconWidth(), image.getIconHeight(), 2);
				Graphics g = bi.getGraphics();
				image.paintIcon(null, g, 0, 0);
				imageIcon.setImage(bi);
				g.dispose();

			}
			catch(Exception e) {	
				e.printStackTrace();
			}



			// * Rows fuellen *

			if(directoryTable.getHeight() > 0 && directoryTable.getScrollPane().getViewport().getHeight() > 0 && directoryTable.getHeight() < (directory.getHeight())) {

				directoryTable.fillTableWithEmptyRows();		
			}
		

			updateViews();

		}
		catch(Exception e) {
			e.printStackTrace();
			directoryLoading = false;
		}		

		directoryTable.setDirectoryDesign();		

		macC64FileOperator.updateDirLabels();
	}


	public void activateDirectory() {

		activeDirectory = true;		
		directoryTable.getTableHeader().setBackground(new Color(0xb8eebe));

	}

	public void deactivateDirectory() {

		activeDirectory = false;		
		directoryTable.getTableHeader().setBackground(new Color(0xf0f0f0));
	}


	public void selectRow(String fileName) {

		directoryTable.selectRow(fileName);
	}




	private SimpleDateFormat dateFormat = new SimpleDateFormat("dd.MM.yyyy HH:mm");

	final JFileChooser fc = new JFileChooser(); // *  fuer Icons *


	private Object[][] loadDirectoryFiles(String path) {


		File[] fileList = Functions.getDir(path, showHiddenFiles);  

		Object[][] data = new Object[fileList.length][columnNames.length];            

		for(int i = 0;i < fileList.length;i++) {

			ImageIcon imageIcon = new ImageIcon();
			//imageIcon.setDescription(fileList[i].getName());

			if(fileList[i].getAbsolutePath().length() > 0) {

				try {

					Icon image = fc.getUI().getFileView(fc).getIcon(new File(fileList[i].getAbsolutePath()));					
					BufferedImage bi = new BufferedImage(image.getIconWidth(), image.getIconHeight(), 2);
					Graphics g = bi.getGraphics();
					image.paintIcon(null, g, 0, 0);
					g.dispose();

					imageIcon.setImage(bi);
				}
				catch(Exception e) {

					e.printStackTrace();					

					if(fileList[i].isDirectory() && fileList[i].getName().contains(".app") == false) 	imageIcon.setImage(dirImage);
					else if(fileList[i].isFile() || fileList[i].getName().contains(".app") == true) {

						if(fileList[i].getName().contains(".app") == true) 	imageIcon.setImage(appImage);
						else if(fileList[i].isFile()) 						imageIcon.setImage(fileImage);
					}						
				}
			}


			data[i][0] = imageIcon;
			data[i][1] = fileList[i].getName();
			data[i][2] = " " + Functions.convertLengthToMemory(fileList[i].length()) ;

			if(fileList[i].getName().toLowerCase().contains(".prg") 
					|| fileList[i].getName().toLowerCase().contains(".p00")
					|| fileList[i].getName().toLowerCase().contains(".t64")) data[i][2] = "("+((fileList[i].length()/1000)*4)+")  " + data[i][2];


			if(fileList[i].isDirectory() ) data[i][2] = " --";
			if(fileList[i].length() == 0 ) data[i][2] = " Zero bytes" ;

			if(fileList[i].getName().equals("..")) {

				data[i][2] = "";
			}
		}
		return data;		
	}	
}