package main;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.AffineTransform;

import javax.swing.BorderFactory;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JComponent;
import javax.swing.JLayeredPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultCaret;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.Highlighter;
import javax.swing.text.JTextComponent;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;
import javax.swing.text.html.StyleSheet;

import d64.D64;
import ffilechooser.FButton;
import ffilechooser.FCheckBox;
import ffilechooser.FFrame;
import ffilechooser.FFrameListener;
import ffilechooser.FLabel;
import ffilechooser.FPanel;
import ffilechooser.FRadioButton;
import ffilechooser.FTextArea;
import ffilechooser.FTextPane;
import ffilechooser.FTextField;

public class Popup {


	public FFrame fframe;
	FPanel panel;

	static float frameWidth = 0.15f;
	static float frameHeight = 0.14f;

	static Font baseFont;

	MacC64FileOperator macC64FileOperator;

	Font c64Font;


	public Popup(MacC64FileOperator macC64FileOperator) {

		this.macC64FileOperator = macC64FileOperator;

		fframe = new FFrame(new FFrameListener() {
			@Override
			public void monitorResolutionChanged() {}
			@Override
			public void frameResized() {}
			@Override
			public void frameMoved() {}
		});


		fframe.addWindowListener(new WindowAdapter()	{
			public void windowClosing(WindowEvent e) {
				windowClosePressed();
			}
		});

		fframe.setTitle("Mac C64 File Operator");
		fframe.setResizable(false);

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

		fframe.setSize(frameWidth, frameHeight);
		fframe.setMinimumSize(frameWidth, frameHeight);
		fframe.setLocation(d.width/2-fframe.monitor.convertFloatToRealWidth(frameWidth/2), d.height/2-fframe.monitor.convertFloatToRealHeight(frameHeight/2));

		// * Hide Toolbar *
		fframe.setUndecorated(false);


		fframe.setForeground(Color.WHITE);
		fframe.setVisible(false);
		fframe.setLayout(null);
		fframe.setBackground(new Color(238,238,238));
		fframe.setFocusable(true);

		fframe.setAlwaysOnTop(true);		

		c64Font	 = new Font("Commodore 64", Font.PLAIN, macC64FileOperator.fframe.monitor.convertFloatToRealHeight(0.013f));

		panel = new FPanel(fframe);
		panel.setOpaque(true); //content panes must be opaque	

		fframe.pack();
	}


	private void windowClosePressed() {

		stop();
		close();				

	}

	private void clear() {
		
		panel.removeAll();

	}
	
	private void show() {

		fframe.setContentPane(panel);
		fframe.pack();
		fframe.setVisible(true);
	}

	public void close() {

		pressed = true;
		fframe.dispose();	
	}

	private void stop() {


	}	

	public void pleaseWait() {

		show();		

		FLabel text = new FLabel(fframe);
		text.setText("Please Wait...");
		text.setBounds(0.054f, 0.054f, 0.1f, 0.1f);
		text.setFontSize(0.013f);		
		panel.add(text);
	}


	boolean pressed 			= false;
	boolean result 			= false;
	int resultInt			= -1;
	String resultText 		= null;
	String[] diskNameAndID 	= null;
	
	FCheckBox nibblerOption;
	
	public boolean question(String text) {

		// * This have to be inside a new Thread!!! *

		float fontSize = 0.012f;

		pressed 	= false;		
		result 	= false;

		clear();
		
		FTextPane textPane = new FTextPane(fframe);
		textPane.setText(text);
		//textLabel.setBorder(BorderFactory.createLineBorder(Color.GRAY, 1));
		textPane.setBounds(0.011f, 0.026f, 0.13f, 0.040f);
		textPane.setFontSize(fontSize);		
		textPane.setEditable(false);  
		textPane.setCursor(null);
		textPane.setOpaque(true);  
		textPane.setBackground(new Color(238,238,238));
		textPane.setFocusable(false); 

		StyledDocument doc = textPane.getStyledDocument();
		SimpleAttributeSet center = new SimpleAttributeSet();
		StyleConstants.setLineSpacing(center, 0.24f);
		StyleConstants.setAlignment(center, StyleConstants.ALIGN_CENTER);
		doc.setParagraphAttributes(0, doc.getLength(), center, false);
		panel.add(textPane);



		FButton positivebutton = new FButton(fframe);
		positivebutton.setBounds(0.034f, 0.08f, 0.035f, 0.02f);
		positivebutton.setFontSize(fontSize);		
		positivebutton.setText("Ok");
		positivebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {result = true; pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(positivebutton);

		FButton negativebutton = new FButton(fframe);
		negativebutton.setBounds(0.082f, 0.08f, 0.035f, 0.02f);
		negativebutton.setFontSize(fontSize);		
		negativebutton.setText("Cancel");
		negativebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {result = false; pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(negativebutton);

		
		show();		

		
		while(pressed == false) {			
			try {Thread.sleep(100);} catch (InterruptedException e1) {e1.printStackTrace();}			
		}

		close();

		return result;
	}



	public int backupQuestion(String text) {

		// * This have to be inside a new Thread!!! *

		float fontSize = 0.012f;

		pressed 	= false;		
		result 	= false;

		clear();
		
		FTextPane textPane = new FTextPane(fframe);
		textPane.setText(text);
		//textLabel.setBorder(BorderFactory.createLineBorder(Color.GRAY, 1));
		textPane.setBounds(0.011f, 0.012f, 0.13f, 0.040f);
		textPane.setFontSize(fontSize);		
		textPane.setEditable(false);  
		textPane.setCursor(null);
		textPane.setOpaque(true);  
		textPane.setBackground(new Color(238,238,238));
		textPane.setFocusable(false); 

		StyledDocument doc = textPane.getStyledDocument();
		SimpleAttributeSet center = new SimpleAttributeSet();
		StyleConstants.setLineSpacing(center, 0.24f);
		StyleConstants.setAlignment(center, StyleConstants.ALIGN_CENTER);
		doc.setParagraphAttributes(0, doc.getLength(), center, false);
		panel.add(textPane);

		
		nibblerOption = new FCheckBox(fframe);
		nibblerOption.setText("Make a Nibble Copy (.nib/.g64)");
		nibblerOption.setFontSize(fontSize*0.85f);
		nibblerOption.setBounds(0.03f, 0.055f, 0.15f, 0.011f*1.777f);
		panel.add(nibblerOption);
		

		FButton positivebutton = new FButton(fframe);
		positivebutton.setBounds(0.034f, 0.085f, 0.035f, 0.02f);
		positivebutton.setFontSize(fontSize);		
		positivebutton.setText("Ok");
		positivebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {resultInt = 1; if(nibblerOption.isSelected()) resultInt = 2 ;pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}	
		});
		panel.add(positivebutton);

		FButton negativebutton = new FButton(fframe);
		negativebutton.setBounds(0.082f, 0.085f, 0.035f, 0.02f);
		negativebutton.setFontSize(fontSize);		
		negativebutton.setText("Cancel");
		negativebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {resultInt = -1; pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(negativebutton);
		
		
		show();		

		
		while(pressed == false) {			
			try {Thread.sleep(100);} catch (InterruptedException e1) {e1.printStackTrace();}			
		}

		close();

		return resultInt;
	}


	class RenameInputFieldCustomCaret extends DefaultCaret {

		public void paint(Graphics g) {

			JTextComponent comp = getComponent();
			if (comp == null) return;

			Rectangle r = null;
			try {
				r = comp.modelToView(getDot());
				if (r == null) return;
			} catch (BadLocationException e) { return; }

			r.height =  comp.getHeight(); 	        

			// * "convertFloatToRealfWidth()" return not "int", it return "float", because we have a Font Char width of 13.5 and not 13 or 14!!! * 
			float width = fframe.monitor.convertFloatToRealfWidth(0.0052781253f);	        

			int pos = (int)(fframe.monitor.convertFloatToRealfWidth(0.003125f) + comp.getCaretPosition()*width);
			if(pos < 10) pos = 10;
			
			if (isVisible()) g.fillRect(pos, r.y, 2, r.height);
		}
	}


	public String inputField(String text, String fieldText, boolean c64File) {

		float fontSize = 0.012f;

		pressed 	= false;		
		resultText 	= null;

		clear();		

		FLabel textLabel = new FLabel(fframe);
		textLabel.setText(text);
		textLabel.setHorizontalAlignment(FLabel.CENTER);
		textLabel.setBounds(0.010f, 0.022f, 0.13f, 0.1f);
		textLabel.setFontSize(fontSize);			
		panel.add(textLabel);


		FTextField textField = new FTextField(fframe);

		if(c64File) {


			textField.addKeyListener(new KeyAdapter() {
				@Override
				public void keyTyped(KeyEvent e) {

					if (textField.getText().length() >= 16 ) { // C64 has only 16 Characters
						e.consume(); 
					}
					else {
						e.setKeyChar((char)D64.reverseCase("" +  e.getKeyChar( )).charAt(0));
					}
				}
			});

			textField.setFont(c64Font);
			textField.setCaret(new RenameInputFieldCustomCaret());
		}


		textField.setText(fieldText);
		textField.setBounds(0.027f, 0.052f, 0.095f, 0.11f);
		textField.setFontSize(fontSize);				
		panel.add(textField);

		FButton positivebutton = new FButton(fframe);
		positivebutton.setBounds(0.034f, 0.090f, 0.035f, 0.02f);
		positivebutton.setFontSize(fontSize);		
		positivebutton.setText("Ok");
		positivebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {resultText = textField.getText(); pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(positivebutton);

		FButton negativebutton = new FButton(fframe);
		negativebutton.setBounds(0.082f, 0.090f, 0.035f, 0.02f);
		negativebutton.setFontSize(fontSize);		
		negativebutton.setText("Cancel");
		negativebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {resultText = null; pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(negativebutton);

		show();

		while(pressed == false) {			
			try {Thread.sleep(100);} catch (InterruptedException e1) {e1.printStackTrace();}			
		}

		close();

		return resultText;
	}


	public String[] inputFieldDisknameAndID(String text, String diskName, String diskID) {

		float fontSize = 0.012f;

		pressed 	= false;		
		diskNameAndID 	= null;

		clear();		

		FLabel textLabel = new FLabel(fframe);
		textLabel.setText(text);
		textLabel.setHorizontalAlignment(FLabel.CENTER);
		textLabel.setBounds(0.010f, 0.016f, 0.13f, 0.1f);
		textLabel.setFontSize(fontSize);			
		panel.add(textLabel);


		FTextField textField = new FTextField(fframe);
		FTextField textField2 = new FTextField(fframe);



		textField.addKeyListener(new KeyAdapter() {
			@Override
			public void keyTyped(KeyEvent e) {

				if (textField.getText().length() >= 16 ) { // C64 has only 16 Characters
					e.consume(); 
				}
				else {
					e.setKeyChar((char)D64.reverseCase("" +  e.getKeyChar( )).charAt(0));
				}
			}
		});

		textField.setFont(c64Font);
		textField.setCaret(new RenameInputFieldCustomCaret());



		textField2.addKeyListener(new KeyAdapter() {
			@Override
			public void keyTyped(KeyEvent e) {

				if (textField2.getText().length() >= 5) { // C64 has only 16 Characters
					e.consume(); 
				}
				else {
					e.setKeyChar((char)D64.reverseCase("" +  e.getKeyChar( )).charAt(0));
				}
			}
		});

		textField2.setFont(c64Font);
		textField2.setCaret(new RenameInputFieldCustomCaret());



		textField.setText(diskName);
		textField.setBounds(0.027f, 0.025f, 0.095f, 0.11f);
		textField.setFontSize(fontSize);				
		panel.add(textField);

		textField2.setText(diskID);
		textField2.setBounds(0.055f, 0.048f, 0.042f, 0.11f);
		textField2.setFontSize(fontSize);				
		panel.add(textField2);

		FButton positivebutton = new FButton(fframe);
		positivebutton.setBounds(0.034f, 0.090f, 0.035f, 0.02f);
		positivebutton.setFontSize(fontSize);		
		positivebutton.setText("Ok");
		positivebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) { diskNameAndID = new String[] {textField.getText(), textField2.getText()}; pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(positivebutton);

		FButton negativebutton = new FButton(fframe);
		negativebutton.setBounds(0.082f, 0.090f, 0.035f, 0.02f);
		negativebutton.setFontSize(fontSize);		
		negativebutton.setText("Cancel");
		negativebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {resultText = null; pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(negativebutton);

		show();
		
		while(pressed == false) {			
			try {Thread.sleep(100);} catch (InterruptedException e1) {e1.printStackTrace();}			
		}

		close();

		return diskNameAndID;
	}




	public void hint(String text) {

		float fontSize = 0.012f;

		pressed 	= false;		
		resultText 	= null;

		clear();		

		FTextPane textPane = new FTextPane(fframe);
		textPane.setText(text);
		//textLabel.setBorder(BorderFactory.createLineBorder(Color.GRAY, 1));
		textPane.setBounds(0.011f, 0.046f, 0.13f, 0.040f);
		textPane.setFontSize(fontSize);		
		textPane.setEditable(false);  
		textPane.setCursor(null);
		textPane.setOpaque(true);  
		textPane.setBackground(new Color(238,238,238));
		textPane.setFocusable(false); 

		StyledDocument doc = textPane.getStyledDocument();
		SimpleAttributeSet center = new SimpleAttributeSet();
		StyleConstants.setLineSpacing(center, 0.24f);
		StyleConstants.setAlignment(center, StyleConstants.ALIGN_CENTER);
		doc.setParagraphAttributes(0, doc.getLength(), center, false);
		panel.add(textPane);
		
		show();

	}


	public void hintWithButton(String text) {

		float fontSize = 0.012f;

		pressed 	= false;		
		resultText 	= null;

		clear();		

		FTextPane textPane = new FTextPane(fframe);
		textPane.setText(text);
		//textLabel.setBorder(BorderFactory.createLineBorder(Color.GRAY, 1));
		textPane.setBounds(0.011f, 0.026f, 0.13f, 0.040f);
		textPane.setFontSize(fontSize);		
		textPane.setEditable(false);  
		textPane.setCursor(null);
		textPane.setOpaque(true);  
		textPane.setBackground(new Color(238,238,238));
		textPane.setFocusable(false); 


		StyledDocument doc = textPane.getStyledDocument();
		SimpleAttributeSet center = new SimpleAttributeSet();
		StyleConstants.setLineSpacing(center, 0.24f);
		StyleConstants.setAlignment(center, StyleConstants.ALIGN_CENTER);
		doc.setParagraphAttributes(0, doc.getLength(), center, false);
		panel.add(textPane);


		FButton positivebutton = new FButton(fframe);
		positivebutton.setBounds(0.0575f, 0.090f, 0.035f, 0.02f);
		positivebutton.setFontSize(fontSize);		
		positivebutton.setText("Ok");
		positivebutton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {	}
			@Override
			public void mousePressed(MouseEvent e) {pressed = true;}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		panel.add(positivebutton);

		show();
		
		while(pressed == false) {			
			try {Thread.sleep(100);} catch (InterruptedException e1) {e1.printStackTrace();}			
		}

		close();		
	}



}
